/*  Death Scripts Modules 4.0.8
 *  DrDeath@Undernet
 *
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#define MAKING_DS40
#define MODULE_NAME "ds40"
#define MODULE_VERSION "4.0.1.6"
#define OUTPUT_VERSION "\002Death Scripts 4.1.0 MODULE\002"
#define AD_VERSION "\002DS 4.1.0\002"
#include "../module.h"
#include "../irc.mod/irc.h"
#include "../server.mod/server.h"
#include "../channels.mod/channels.h"
#include <stdlib.h>
#include <sys/stat.h>
#include <time.h> /* for time_t */
#include <ctype.h>
#undef global
static Function *global = NULL, *irc_funcs = NULL, *server_funcs = NULL, *channels_funcs = NULL, *blowfish_funcs = NULL;
#ifndef EGG_IS_MIN_VER
#define EGG_IS_MIN_VER(ver)             ((ver) <= 10400)
#endif
#ifndef Context
#define Context context
#endif
static struct strikes_global    *sdata = NULL;
static char strikesfile[121] = "strikes.dat";
#include "ds40.h"
#include "sensors.c"
#include "dcccmds.c"
#include "msgcmds.c"
// #include "tclcmds.c"


//static time_t mstat_time = 0;


static int ds40_expmem()
{
  int size = 0;
  struct strikes_global *sl = sdata;

  Context;
  while (sl) {
    size += sizeof(struct strikes_global);

    size += strlen(sl->host);
    size += 4;
    
    sl = sl->next;
  }
  Context;
  return size;
}



static void free_ds40()
{
  struct strikes_global *sl;

  Context;
  while (sdata) {
    sl = sdata->next;
    Context;
    nfree(sdata->host);
    Context;
    nfree(sdata);
    Context;
    sdata = sl;
  }
  Context;
  return;
}

static int matchattr (struct userrec *u, char *flags, char *chan) 
{
  struct flag_record plus, minus, user;
  int ok = 0, f;

  Context;

  if (u && (!chan || findchan(chan))) {
    Context;
    user.match = FR_GLOBAL | (chan ? FR_CHAN : 0) | FR_BOT;
    get_user_flagrec(u, &user, chan);
    plus.match = user.match;
    break_down_flags(flags, &plus, &minus);
    f = (minus.global || minus.udef_global || minus.chan ||
   minus.udef_chan || minus.bot);
    if (flagrec_eq(&plus, &user)) {
      Context;
      if (!f)
  ok = 1;
      else {
  minus.match = plus.match ^ (FR_AND | FR_OR);
  if (!flagrec_eq(&minus, &user))
    ok = 1;
      }
    }
  }
  Context;
  return ok;
}


static void strlower(char *text)
{
  int i;

  for (i = 0; i < strlen(text); i++)
    text[i] = tolower(text[i]);
}
  

/*static tcl_ints my_tcl_ints[] =
{

  {"strikes-file-mode", &statsfilemode, 0},
  {0, 0, 0}
};

static tcl_strings my_tcl_strings[] =
{
  {"strikesfile", statsfile, 121, 0},
  {0, 0, 0, 0}
};
*/



static void strikes_hourly()
{
  Context;
  PurgeKicks();
  write_strikes();
  Context;
}

static void PurgeKicks()
{
   struct strikes_global *sl;
   struct strikes_global *head;
   struct strikes_global *newlist;
//   newlist = nmalloc(sizeof(gs));
   head = NULL;
   if(sdata)
    sl = sdata;
   else
     return;  //cant purge nothing...

   while(sl)
   {
       if((now - sl->started) > 18000)
       {
         sl = sl->next;
	 
       }
       else
       {
          newlist = nmalloc(sizeof(gs));
          newlist->host = nmalloc(strlen(sl->host)+1);
          newlist->host = sl->host;
          newlist->started = sl->started;
          newlist->kicks = sl->kicks;
          
          newlist->next = NULL;
          if(!head)
            head = newlist;
          newlist = newlist->next;
	  sl = sl->next;
       }
    }
    if(head)
    {
      //free_strikes();
//      putlog(LOG_MISC,"*",head->host);
      sdata = head;
    }
    if(!head) //this means ALL kicks were old, everyones been good
      sdata = NULL;
   write_strikes(); //write out updated data file

}



 static char *ds40_close()
{
  Context;

  write_strikes();
  free_ds40();
  del_hook(HOOK_HOURLY, (Function) strikes_hourly);
  rem_builtins(H_msg, ds40_msg);
  rem_builtins(H_kick, got_kick);
  rem_builtins(H_dcc, mydcc);
  rem_builtins(H_chon, new_chat); 
// rem_tcl_ints(my_tcl_ints);
//  add_tcl_commands(mytcls);



  rem_help_reference("deathscripts4.0.help");

  module_undepend(MODULE_NAME);
  return NULL;
}






static void ds40_report(int idx, int details)
{
  int size = 0;

  Context;
  if (details) {
    size = ds40_expmem();
    dprintf(idx, "    using %d bytes\n", size);
  }
}
char *ds40_start();

static Function ds40_table[] =
{
  (Function) ds40_start,
  (Function) ds40_close,
  (Function) ds40_expmem,
  (Function) ds40_report,
};

char *ds40_start(Function * global_funcs)
{
  module_entry *me;
  global = global_funcs;
  Context;
  module_register(MODULE_NAME, ds40_table, 0, 1);
  if (!(irc_funcs = module_depend(MODULE_NAME, "irc", 1, 0)))
    return "You need the irc module to use the stats module.";
  if (!(server_funcs = module_depend(MODULE_NAME, "server", 1, 0)))
    return "You need the server module to use the stats module.";
  if (!(channels_funcs = module_depend(MODULE_NAME, "channels", 1, 0)))
    return "You need the channels module to use the stats module.";
 if (!module_depend(MODULE_NAME, "eggdrop", 106, 1))
     return "This module requires eggdrop1.6.1 or later";
 me = module_find("encryption",2,0);
 blowfish_funcs = me->funcs;
  add_builtins(H_dcc, mydcc);
  add_builtins(H_msg, ds40_msg);
//  add_tcl_ints(my_tcl_ints);
//  add_tcl_strings(my_tcl_strings);
  add_builtins(H_kick, got_kick);
  add_builtins(H_chon, new_chat);
  add_hook(HOOK_HOURLY, (Function) strikes_hourly);
  add_help_reference("deathscripts4.0.help");
//  add_tcl_commands(mytcls);
  read_strikes();
  putlog(LOG_MISC, "*", "%s \002loaded.\002", OUTPUT_VERSION);
  return NULL;
}
